diary on

% Curso de Introducción al Cálculo Científico con Octave
%
% Guión para la segunda sesión: Funcionamiento básico y primeros ejemplos

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. Octave como una calculadora
%
% Ejecutamos los siguientes comandos desde el terminal (a continuación del prompt >>> en la Línea de Comandos

pwd  % Print Working Directory
ls
cd midirectorio  % para cambiar de directorio

3+5
5-8
2*9  %ojo, que no se puede dejar un espacio en blanco (probar)
6/8  %no es lo mismo que 6\8 (probarlo)
3^2
sqrt(81)

% Ctrl+C para interrumpir la ejecución de un comando
% el "punto y coma" para no mostrar el resultado
3+5;

% Escribir comandos largos en varias líneas: separar las líneas con tres puntos seguidos ... 

2+3 ...
+5

2+3 ...
*5

% También se pueden incluir varios comandos en una misma línea, separándolas por comas o punto y coma

2+3, 5*8

% Últimos comandos utilizados en la ventana "Command List". Podemos recuperarlos en la Command Line usando las flechas "subir" y "bajar"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% 2. Números reales y complejos. 

% La parte compleja se representa con el símbolo "i", cuyo coeficiente se escribe juxtapuesto ¡sin dejar ningún espacio!
% Es conveniente escribir siempre el coeficiente imaginario, aunque sea 1. 
% También se puede escribir con la letra "j" o con "I" o con "J".

2+1i 
(3+4i)*5i
9.3+5i*(1+2i)
2.5-3i+5j
(2+1i)/(1-6i)
(5-2i)^2

imag(8+3i)
real(8+3i)
abs(8+3i)
conj(8+3i)
angle(8+3i) % argumento en radianes

% el infinito
1/0
inf
Inf

% resultados no definidos
0/0
inf/inf
% en ambos casos el resultado es NaN (Not a Number)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% 3. Tipos de datos: precisión

realmax
realmin
10^309 
10^-323
10^-324
eps

1/7 % lo muestra con 5 cifras
format long 
1/7 % lo muestra con 15 cifras

1-1+10^(-16) 
1-(1+10^(-16)) 
x=10^(-15); (1+x)/x-1/x 
x=10^(-15); ((1+x)-1)/x 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% 4. Variables
% el nombre de la variable puede estar compuesto por letras, números y "_", pero no pueden empezar por un número
% Distingue entre mayúsculas y minúsculas

z=4+3j
imag(z)
z^2

a=3
b=5-6i
c=a+b

% el valor de una variable puede cambiar a lo largo de la sesión
a=5
c
a=a+2

% Borrar alguna/s variable/s (observar el efecto en la ventana "Vairable List")

clear('a','b')

% Borrar todas las variables: el comando "clear all" ó "clear()"
clear all
clear()

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Cadenas de caracteres: entre comillas simples ' '

s =  'hola clase, yo soy una cadena de caracteres'

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Variables y algunas funciones predefinidas

e 
pi
exp(1i*pi)
sqrt(25)
sin(pi)
cos(pi)
tan(pi)

log(1) %es el logaritmo neperiano
log(e)

abs(-7)
abs(1+1i)

rand() %número aleatorio entre 0 y 1, según una distribución uniforme
rand(1,2)
rand(2,1)

gamma(3) %función gamma \gamma(z)=\int_0^\infty t^{z-1} e^{-t} dt; \gamma(n)=(n-1)!
beta(3,4) % beta (a, b) = gamma (a) * gamma (b) / gamma (a + b).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Vectores y matrices: MATLAB =  MATrix LABoratory

A=[1,2; 3,4] 
a=[5,6] % vector fila
b=[7; 8] %vector columna
% observar los datos en la ventana "Variable List"

% Definición alternativa (no recomendable).

A=[ 1 2
3 4]

a=[5 6]

b=[7
8]

% Otra forma de definir matrices mediante rangos: para valores equiespaciados

x=[2:7] % ó simplemente x=2:7. 
x=[2:7.5]
y=[2:0.5:7] % ó simplemente y=2:0.5:7
z=linspace(2,7,5) % 5 nodos entre 2 y 7

% Para extraer los elementos de un vector

b(1)
a(2)

% Sin embargo
A(1)
A(2)
A(3)
A(4)

% Para extraer los elementos de una matriz

A(1,2)
A(2,2)

% Para extraer submatrices

A(1:2,1) 
A(2,1:2)

M=rand(6,5)
M([1,2],[1,4])
M(:,[1,2,3])

% Esto nos permite hacer una permuta de filas o columnas con mucha facilidad

M([1,2],:)=M([2,1],:)

% y si queremos eliminar una fila o una columna

M(1,:)=[]  % eliminamos la primera fila
M(:,3)=[]  % eliminamos la tercera columna
M(:,end)=[]  % eliminamos la última columna
M(end,:)=[]  % eliminamos la última fila

% Para ver el tamaño de una matriz

size(A)
length(a)
length(b)

size(a)
size(b)
length(A)

length([1,2,3; 4,5,6])
length([1,2; 3,4; 5,6])

% se pueden combinar matrices, siempre que las dimensiones sean correctas
A=[1,2;3,4]
B=[5,6,7;8,9,0]
C=[A,B]
[A,b]
[A;a]
 
 % sin embargo
 [A;B]

% También podemos inicializar una matriz vacía con el comando "[]"

M=[]

 % y ahora ir completándola

M(1,1)=8
M(3,4)=-2   % los elementos no introducidos se completan con ceros

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Tipos especiales de matrices

zeros(3,2)
ones(3,4)
eye(5)     % identidad
eye(3,5)  % unos en la diagonal
rand(2,3)
v=[1,2,3]
diag(v,0)
diag(v,1)
diag(v,-2)

% y otras matrices especiales conocidas

hankel([1,2,3])  % Hankel(C)  C=first column
hankel([1,2,3],[3,4,5])  % Hankel(C,R)  C=first column R=last row
hankel([1,2,3],[3,4,5]) % Hankel
hilb(4)        % Hilbert
invhilb(4)    % Inverse of a Hilbert matrix
toeplitz([1,2,3])    % Toeplitz(C)  C=first column
toeplitz([1,2,3],[1,4,5])    % Toeplitz(C,R)  C=first column R=first row 
toeplitz([1,2,3],[3,4,5])    % Toeplitz matrix
vander([1,2,3,4,5])  % Vandermonde matrix vander(C) C= penúltima columna
vander([1,2,3,4,5],3) % número de columnas

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Operaciones con Vectores y matrices

A=[4,6,-2; 3,6,10; 0,5,-1]
B=[1,4; 4,7; 9,-2]
C=[-2,7,5; 5,4,3; 1,-6,1]
a=[-1,4,7]
b=[0;-3;5]

% Octave diferencia entre vectores fila y vectores columna

a+b
a+b'
a'-b

% si uno de los sumandos es un escalar

2+a
3-A

% operaciones elemento a elemento

A.*C
A./C
A.^2
A.*B

% Operaciones matriciales

A*B
B*A

A^2
B^2

A^-1

A\b % resuelve el sistema A.x=b sin calcular A^-1 
A\C
A\C(:,1)
A\C(:,2)
A\C(:,3)

det(A)
inv(A)

A\b
inv(A)*b

inv([1,2;2,4])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%  Algunos comandos para reordenar matrices

A
fliplr(A) % reordena por columnas
flipud(A) % reordena por filas
reshape(A,9,1)
reshape(A,1,9)
A
resize(A,2,3)
resize(A,3,2)
resize(A,2,4)

tril(A) % extrae la parte triangular inferior
tril(A,-1)
triu(A) % extrae la parte triangular superior
triu(A,1)

A
diag(A)
diag(diag(A))
diag(A,1)

vec(A)
A(:)
vec(A,1)
vec(A,2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Polinomios

% La entrada de un polinomio es un vector con los coeficientes

p0=[1]  % este es p(x)=1
p1=[1,0] % este es p(x)=x
p2=[1,0,0] % p(x)=x^2

p=[4,7,0,1,0,0] % es el polinomio p(x)=4x^5+7x^4+x^2
polyout(p,'x')   % para mostrarlo "bonito"

% el polinomio se evalua con

polyval(p) % usa el algoritmo de Hörner-Ruffini
polyval(p0,2)
polyval(p1,2)
polyval(p2,2)

polyval(p,1.4)

% evaluación de un polinomio en forma matricial

polyvalm(p,A)  % usa multiplicacion matricial
polyval(p,A)

% cálculos con polynomios: para sumarlos, tenemos que tener los vectores de la misma dimensión
p0
p1
p0+p1 % lo hace mal porque p0 es un escalar!
p0=[0,1]
p0+p1
p1+p2
p0=[0,p0]
p1=[0,p1]
p0+p1+p2

% en la proxima sesión crearemos una función para sumar polinomios

% hacemos una combinación lineal
q = [6,0,-1,1];
p = [2,1,4,-3];
r = [4,-1,0];
3*p-8*q
3*p-8*q+r
r=[0,r];
3*p-8*q+r

% producto de dos polinomios

q = [6,0,-1,1];
p = [2,1,4,-3];
r = [4,-1,0];
conv(p,q)
conv(p,r)

% división de polynomios

deconv(p,q)  % devuelve el cociente y el resto tal que p=c*q+r
[co,re]=deconv(p,q)
[co,re]=deconv(p,r)

% derivación e integración de polinomios
p
polyderiv(p)
polyint(p)

% cálculo de raíces

roots(p)

% polinomio que tenga ciertas raíces

poly([2,3,-1])  % genera el polinomio mónico cuyas raíces son 2,3 y -1

% ojo, algunos comandos actuan de forma diferente sobre vectores o sobre matrices

p
polyval(p,2)  % ya lo hemos visto, evalúa p en x=2
polyval(p,[1,2,3])  % evalúa p en cada componente del vector
polyval(p,[1,2;3,4])  % ya lo hemos visto, evalúa componente a componente. Para que evalúe matricial, hay que usar polyvalm

poly([1,2;3,4])  % genera el polynomio característico de la matriz



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Archivos .m
%
% Las instrucciones se pueden proporcionar directamente en la Linea de Comandos, o a través de archivos .m
% crear el archivo miprimerarchivo.m
% para ejecutarlo, teclear "miprimerarchivo" en la Linea de Comandos

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Cómo guardar nuestro trabajo: salvar la sesión con el comando "diary"

diary diariosesion2.txt % nombre del archivo donde se guardarán los datos. Si no se pone nada, el nombre por defecto es "diary"

diary on  % empieza a guardar

3+5
a= 24
x=0:0.1:10
plot(x,sin(x))

diary off  % termina de guardar

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Guardar las variables en un archivo .mat y recuperarlas posteriormente

save eltrabajodehoy

load eltrabajodehoy %para recuperar las variables guardadas

% si solo queremos guardar una o algunas variables
save A
save filename A 
save filename A a b

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
diary off